#include <stdio.h>
#include <unistd.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>

main (int argc, char **argv) {
  char buf[PATH_MAX];
  pid_t pid;
  if ( argc < 2 ) {
    fprintf(stderr,"%s: Requires at least one argument\n", argv[0]);
    exit(-1);
  }

  if ((pid = fork()) < 0) {
    snprintf(buf, sizeof(buf), "%s: Couldn't fork",argv[0]);
    perror(buf);
    exit(-1);
  } else if (pid > 0) {
    /* Parent */
    int status;
    int ret;

    do {
      if ((ret = waitpid(pid, &status, 0)) < 0 && errno == EINTR)
        continue;
      else if (ret < 0) {
        perror("waitpid failed");
        exit(1);
      }
    } while (0);

    if (WIFEXITED(status))
      exit(WEXITSTATUS(status));
    else
      exit(1);
  } else {
    /* Child */
    execv(argv[1], &argv[1]);

    snprintf(buf, sizeof(buf), "%s: Error execing %s", argv[0], argv[1]);
    perror(buf);
    exit(-1);
  }
}
